'$INCLUDE: 'quick.bi'

DEFSNG A-Z
FUNCTION a20control% (handle%, switch%)
REGISTERS.AX = &H4308
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
IF REGISTERS.AX \ 256 = &H43 THEN
switch% = REGISTERS.BX \ 256
handle% = REGISTERS.BX MOD 256
a20control% = 1
ELSE
a20control% = 0
END IF
END FUNCTION

FUNCTION apminstalled% (major%, minor%, flag%)
REGISTERS.AX = &H5300
REGISTERS.BX = 0
CALL INTERRUPTX(&H15, REGISTERS, REGISTERS)
IF REGISTERS.flags MOD 2 = 0 THEN
apminstalled% = 1
major% = VAL(HEX$(REGISTERS.AX \ 256))
minor% = VAL(HEX$(REGISTERS.AX MOD 256))
flag% = REGISTERS.CX
ELSE
apminstalled% = 0
END IF
END FUNCTION

FUNCTION charstop$ (j%, temp$, llimit%, ulimit%)
temp% = LEN(temp$)
DO UNTIL ASC(MID$(temp$, j%, 1)) < llimit% OR ASC(MID$(temp$, j%, 1)) > ulimit% OR j% = temp%
x$ = x$ + MID$(temp$, j%, 1)  'citire string computer
j% = j% + 1
LOOP
charstop$ = x$
END FUNCTION

FUNCTION CheckMSCDEX%
REGISTERS.AX = &H150C
REGISTERS.BX = &H0
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
IF ((REGISTERS.BX AND &HFF00) / 256) <> 0 THEN
CheckMSCDEX% = 1
ELSE
CheckMSCDEX% = 0
END IF
END FUNCTION

FUNCTION compst% (st1$, st2$)  ' compara 2 sringuri
rez% = 1
IF LEN(st1$) <> LEN(st2$) THEN
rez% = 0
ELSE
FOR i% = 1 TO LEN(st1$)
x$ = MID$(st1$, i%, 1)
SELECT CASE x$
CASE "#" 'trece mai departe
CASE ELSE
IF x$ <> MID$(st2$, i%, 1) THEN 'diferenta
rez% = 0
END IF
END SELECT
NEXT
END IF
compst% = rez%

END FUNCTION

FUNCTION cores$ (core%)
SELECT CASE core%
CASE 1
temp$ = "Single"
CASE 2
temp$ = "Dual"
CASE 4
temp$ = "Quad"
CASE ELSE
temp$ = STR$(core%) + "th"
END SELECT
cores$ = temp$ + "-core"
END FUNCTION

FUNCTION cpubugs$ (cpuinf AS cpudat)
SHARED cputyp$

FOR k% = 1 TO 8
SELECT CASE k%

CASE 1
IF cpuinf.family = 3 THEN
IF popadbug% = 0 THEN
bug$ = bug$ + "POPAD"
found% = 1
END IF
END IF

CASE 2
IF cpuinf.cr0r AND 1 = 0 THEN
IF locktest% = 1 THEN
bug$ = bug$ + "LOCK NOP"
found% = 1
END IF
END IF

CASE 3
IF cpuinf.family = 5 THEN
IF testndp% = 0 THEN
bug$ = bug$ + "FDIV"
found% = 1
END IF
END IF

CASE 4
IF cpuinf.man = 2 AND cpuinf.family = 5 THEN ' doar AMD K6-2
IF amdtest% OR amdtest% = 1 THEN
bug$ = bug$ + "AMD DRx"
found% = 1
END IF
END IF

CASE 5
IF cpuinf.family >= 5 THEN
w& = &H80000000
cpall w&, x&, y&, Z&
x% = (w& AND &HFF)
FOR x% = 1 TO x%
w& = &H80000000 + x%
cpall w&, x&, y&, Z&
IF ABS(w& OR x& OR y& OR Z&) > 0 THEN
limit% = x%
END IF
NEXT
IF limit% < x% - 1 THEN
found% = 1
bug$ = bug$ + "CPUID limit"
END IF
END IF

CASE 6
IF cpuinf.family >= 5 THEN
IF cpclear% = 1 THEN
found% = 1
bug$ = bug$ + "CPUID clear"
END IF
END IF

CASE 7 ' f00f bug


CASE 8 ' de selectat daca e nocona
IF INSTR(cputyp$, "Nocona") > 0 THEN
w& = &H80000008
cpall w&, x&, y&, Z&
IF w& MOD 256 = &H28 THEN
found% = 1
bug$ = bug$ + "EM64T 40 bit adress"
END IF
END IF
END SELECT

IF found% = 1 THEN
found% = 0
bug$ = bug$ + " failed;"
END IF

NEXT

IF LEN(bug$) = 0 THEN
bug$ = "no known bugs found"
END IF

cpubugs$ = bug$
END FUNCTION

SUB cpucapable (cpuinf AS cpudat)

LOCATE 9, 2
PRINT "Instructions sets" + STRING$(10, 196) + ""
FOR j% = 1 TO 9
LOCATE 9 + j%, 2
k% = -1
PRINT "" + SPACE$(27) + ""
LOCATE 9 + j%, 3
SELECT CASE j%
CASE 1
PRINT "         MMX:";
k% = 23
CASE 2
PRINT "    Ext. MMX:";
IF cpuinf.man = 5 THEN
k% = 24
ELSEIF cpuinf.man = 2 THEN 'numai AMD
k% = 22
END IF
CASE 3
PRINT "         SSE:";
k% = 25
CASE 4
PRINT "        SSE2:";
IF cpuinf.man = 1 THEN
k% = 26
END IF
CASE 5
PRINT "        SSE3:";
IF cpuinf.man = 1 THEN
k% = 32
END IF
CASE 6
PRINT "      IA -64:";
IF cpuinf.man = 1 THEN
k% = 30
END IF
CASE 7
PRINT "     3D Now!:";
IF cpuinf.man = 2 OR cpuinf.man = 5 THEN
k% = 31
END IF
CASE 8
PRINT "Ext. 3D Now!:";
IF cpuinf.man = 2 THEN
k% = 30
END IF
CASE 9
PRINT "      AA -64:";
IF cpuinf.man = 2 THEN
k% = 29
END IF
END SELECT

IF k% > 31 THEN
x& = cpuinf.info2
k% = k% - 32
ELSE
x& = cpuinf.extinfo OR cpuinf.info
END IF

IF k% = 31 THEN
x& = x& AND -32768
ELSE
x& = x& AND (2 ^ k%)
END IF

IF k% > -1 AND x& <> 0 THEN
videorevers (yes$)
ELSE
PRINT no$
END IF
NEXT

PRINT " " + STRING$(27, 196) + ""


LOCATE 9, 40
PRINT "Miscellanous"
FOR j% = 1 TO 11
k% = -1

x& = cpuinf.extinfo OR cpuinf.info

LOCATE 9 + j%, 40
SELECT CASE j%
CASE 1
PRINT "      CMPXCHG8 instruction:";
k% = 8
CASE 2
PRINT "        Time Stamp Counter:";
k% = 4
CASE 3
PRINT "  Model Specific Registers:";
k% = 5
CASE 4
PRINT "     On-chip APIC Hardware:";
k% = 9
CASE 5
PRINT "         Fast system calls:";
IF cpuinf.man = 2 AND cpuinf.family = 5 THEN
k% = 10
ELSE
k% = 11
END IF
CASE 6
PRINT "Machine Check Architecture:";
k% = 14
CASE 7
PRINT "              ACPI support:";
IF cpuinf.man = 1 THEN
k% = 22
END IF
CASE 8
PRINT "     Fast save and restore:";
IF cpuinf.man = 1 THEN
k% = 24
END IF
CASE 9
PRINT "                Self Snoop:";
IF cpuinf.man = 1 THEN
k% = 27
END IF
CASE 10
PRINT "Hyper-Threading Technology:";
IF cpuinf.man = 1 THEN
k% = 28
END IF
CASE 11
PRINT "  Multi-Processing Capable:";
IF cpuinf.man = 2 THEN
k% = 19
END IF
END SELECT




IF k% >= 0 THEN
IF k% = 31 THEN
x& = x& AND -32768
ELSE
x& = x& AND (2 ^ k%)
END IF
END IF

IF (k% > -1 AND x& <> 0) OR k% = -2 THEN
videorevers (yes$)
ELSEIF k% = -1 OR x& = 0 OR k% = -3 THEN
PRINT no$
END IF

NEXT

END SUB

FUNCTION cpuman$ (cpman%)
SELECT CASE cpman%
CASE 1
cpuman$ = "Intel"
CASE 2
cpuman$ = "AMD"
CASE 3
cpuman$ = "UMC"
CASE 4
cpuman$ = "Cyrix"
CASE 5
cpuman$ = "Centaur"
CASE 6
cpuman$ = "RISE"
CASE 7
cpuman$ = "NexGen"
CASE 8
cpuman$ = "Transmeta"
CASE 9
cpuman$ = "SIS"
CASE 10
cpuman$ = "IBM"
CASE 11
cpuman$ = "NEC"
CASE 12
cpuman$ = "C&T"
CASE 13
cpuman$ = "VIA-Cyrix"

CASE ELSE
cpuman$ = unknown$
END SELECT

END FUNCTION

FUNCTION dataread$ (prog$, limit&, sw%)
STATIC poz&
STATIC s%
STATIC handle%
IF sw% = 1 THEN
IF s% = 0 THEN
temp$ = SPACE$(40)
poz& = 1
locatest prog$, "[" + STR$(limit&) + "]", "", poz&, temp$, 1
fopen1 prog$, 0, 0, handle%, er%
fsetloc handle%, poz& + 10
s% = 1
END IF
temp$ = SPACE$(120)
freadline handle%, temp$, slen%, toolong%, er%
temp$ = LEFT$(temp$, slen%)
IF temp$ <> "[E]" THEN
dataread$ = temp$
END IF
END IF
IF er% <> 0 OR temp$ = "[E]" OR sw% = 0 THEN
s% = 0
dataread$ = ""
fclose1 handle%
END IF
END FUNCTION

SUB dmistruct
SHARED dmi   AS dmiinfo
PRINT "DMI structures:";
dmi.sign = "_DMI_"
addr% = &HF000
DO
temp% = findstrinmem%(addr%, 0, 28000, dmi.sign)
IF temp% = -1 THEN
addr% = addr% + &H600   ' atentie
END IF
LOOP UNTIL temp% > -1 OR addr% > &H7FFF

IF temp% > -1 THEN
DEF SEG = addr%
dmi.chksum = PEEK(temp% + 5)
dmi.lenght = PEEK(temp% + 7) * 256 + PEEK(temp% + 6)
dmi.doffset = PEEK(temp% + 9) * 256 + PEEK(temp% + 8)
dmi.dseg = PEEK(temp% + 10) * 256 + PEEK(temp% + 11)
dmi.dseg = dmi.dseg * 16
dmi.ver = PEEK(temp% + &HE)
IF dmi.ver > &H20 THEN
PRINT "found",
PRINT "version:"; VAL(HEX$(dmi.ver)) / 10

DEF SEG = dmi.dseg
PRINT "=========SMBIOS informations============="
PRINT "BIOS ROM size:"; (PEEK(dmi.doffset + 9) + 1) * 64; "kb"

FOR i% = 1 TO 11
SELECT CASE i%
CASE 1
temp$ = "Selectable boot"
k% = 16
CASE 2
temp$ = "BIOS upgrade"
k% = 11
CASE 3
temp$ = "Enhanced HDD specifications"
k% = 19
CASE 4
temp$ = "Booting from CD-ROM"
k% = 15
CASE 5
temp$ = "Booting from PC Card"
k% = 18
CASE 6
temp$ = "ESCD"
k% = 14
CASE 7
temp$ = "ACPI"
k% = 32
CASE 8
temp$ = "Booting from I2O"
k% = 35
CASE 9
temp$ = "Booting from LS-120"
k% = 36
CASE 10
temp$ = "Booting from ZIP"
k% = 37
CASE 11
temp$ = "Booting from IEEE 1394"
k% = 38

END SELECT


IF k% > 31 THEN
k% = k% - 32
IF dmi.ver > 21 THEN
temp% = PEEK(dmi.doffset + &H12)
ELSE
temp% = 0
END IF
ELSEIF k% > 15 THEN
temp% = PEEK(dmi.doffset + &HC)
k% = k% - 16
ELSE
temp% = PEEK(dmi.doffset + &HB)
k% = k% - 8
END IF


IF i% = 7 THEN
LOCATE CSRLIN - 6, 40
ELSEIF i% > 7 THEN
LOCATE , 40
END IF

PRINT temp$ + ":";
IF (2 ^ k% AND temp%) > 0 THEN
PRINT supported$
ELSE
PRINT notsupported$
END IF

NEXT

FOR j% = 1 TO 6
LOCATE 10 + j%, 1

SELECT CASE j%
CASE 1
temp$ = "VL VESA (Video Local Bus VESA)"
k% = 13
CASE 2
temp$ = "PCMCIA (PC card)"
k% = 8
CASE 3
temp$ = "EISA (Enhanced ISA)"
k% = 6
CASE 4
temp$ = "PCI (Peripheral Component Interconnect)"
k% = 7
CASE 5
temp$ = "ISA (Industry Standard Architecture)"
k% = 4
CASE 6
temp$ = "MCA (Micro Channel Architecture)"
k% = 5

END SELECT

'temp$ = "AGP (Accelerated Graphics Port)"

IF k% > 7 THEN
temp% = PEEK(dmi.doffset + &HB)
k% = k% - 8
ELSE
temp% = PEEK(dmi.doffset + &HA)
END IF

IF (2 ^ k% AND temp%) > 0 THEN
videorevers ("[]")
LOCATE CSRLIN - 1, 6
ELSE
PRINT "[ ]  ";
END IF
PRINT temp$

NEXT

'dmi.info2 = (CLNG(PEEK(dmi.doffset + &HD)) * 256 + PEEK(dmi.doffset + &HC))
ELSE
PRINT "invalid"
END IF
DEF SEG

ELSE
PRINT "not found"
END IF
END SUB

FUNCTION doskey%
REGISTERS.AX = &H4800
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
IF REGISTERS.AX MOD 256 <> 0 THEN
doskey% = 1
ELSE
doskey% = 0
END IF
END FUNCTION

FUNCTION DPMIVer% (bit32%, proc%)
REGISTERS.AX = &H1687
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
DPMIVer% = REGISTERS.DX
proc% = REGISTERS.CX MOD 256
bit32% = REGISTERS.BX MOD 2
END FUNCTION

FUNCTION epp% (port%)
REGISTERS.AX = &H200
REGISTERS.BX = &H5050
REGISTERS.CX = &H4500
REGISTERS.DX = port%
CALL INTERRUPTX(&H17, REGISTERS, REGISTERS)
IF REGISTERS.AX \ 256 = 0 THEN
epp% = 1
ELSEIF REGISTERS.AX \ 256 = 3 THEN
epp% = -1
ELSE
epp% = 0
END IF
END FUNCTION

DEFINT A-Z
SUB fmcheck   ' aici trebe inbunatatit mecanismul de detectie in dos
putmsg "Checking Fomalhaut existence...", status%, ff%, er%
IF qexist%("fml.exe" + CHR$(0)) = 0 THEN
SHELL "fml.exe 2772-0032 check"
SHELL "fml.exe flush"
temp% = FREEFILE
OPEN "temp.txt" FOR INPUT AS temp%
INPUT #temp%, st$
IF st$ = "0440-0659" THEN
fomalhaut% = 1
END IF
CLOSE temp%
END IF
putmsg done$, status%, ff%, er%
END SUB

DEFSNG A-Z
SUB fmdisk (disk$, bps%, spcl%, asect&, tsect&)
putmsg "Asking Fomalhaut about disk " + disk$, status%, ff%, er%
SHELL "fml.exe 2772-0032 disk " + disk$
SHELL "fml.exe flush"
temp% = FREEFILE
OPEN "temp.txt" FOR INPUT AS temp%
INPUT #temp%, temp$
INPUT #temp%, bps%, spcl%, asect&, tsect&
CLOSE temp%
KILL "temp.txt"
CLS 2
END SUB

SUB fmsystem (comp$, x%, txmsmemsize&, fxmsmemsize&, keystr$, mb%, wname$, name$, company$, regkey$, wver$, prodid$)
putmsg "Asking Fomalhaut about system...", status%, ff%, er%
SHELL "fml.exe 2772-0032 system"
SHELL "fml.exe flush"
temp% = FREEFILE
OPEN "temp.txt" FOR INPUT AS temp%
INPUT #temp%, comp$, x%, txmsmemsize&, fxmsmemsize&, keystr$, mb%, wname$, name$, company$, regkey$, wver$, prodid$
txmsmemsize& = txmsmemsize& \ 1024
fxmsmemsize& = fxmsmemsize& \ 1024
CLOSE temp%
putmsg done$, status%, ff%, er%
KILL "temp.txt"
END SUB

SUB fullscreen
IF wm% > 0 THEN      ' de pus in procedura
putmsg "Windows forced full screen ;", status%, ff%, er%
IF wm% < 5 THEN
putmsg "(inflate method)...;", status%, ff%, er%
REGISTERS.AX = &H168B
REGISTERS.BX = 0
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)      'marire ecran windows
putmsg done$, status%, ff%, er%
putmsg "Allocate maximum resources...;", status%, ff%, er%
REGISTERS.AX = &H1680
CALL INTERRUPT(&H2F, REGISTERS, REGISTERS)
ELSE
putmsg "(explode method)...;", status%, ff%, er%
SCREEN 12
END IF
putmsg done$, status%, ff%, er%
END IF
END SUB

FUNCTION inrange% (lim1%, lim2%, x%) ' vede daca un nr e intre anumite limite
IF lim1% < x% AND lim2% > x% THEN
inrange% = 1
ELSE
inrange% = 0
END IF
END FUNCTION

SUB logo
LOCATE 3, 1

PRINT "Quick.exe - smart program listing info about your system"
PRINT "Producted by Qware comp. Copyright(c) 2000-2006"
PRINT "This is the beta version 0.72 rev.C"
PRINT
PRINT "Web adress:www.quickexe.go.ro"
PRINT "  e-mail:quickexe@hotmail.com"

PRINT
PRINT "If something goes wrong, try another method  - Quick.exe"
PRINT
PRINT "Works under MS-DOS 4.0+ or Windows (all versions)"
PRINT "Price: 6/15/30 USD"

LOCATE 14, 1
PRINT TAB(40); "Special keys:"
PRINT TAB(40); "<F1> - Help screen (not available yet)"
PRINT TAB(40); "<F4> - Automatic report"
PRINT TAB(40); "<F6> - Fast report"
PRINT TAB(40); "<F7> - Alive test"
PRINT TAB(39); "<F10> - Quit"
PRINT "Any non-special key (or left click) - go to next screen"
PRINT "<Esc> (or right click)              - skip next text"


LOCATE 16, 1
PRINT "Quick.exe running in ";
SELECT CASE status%
CASE 0
PRINT "normal ";
CASE 1
PRINT "trace ";
CASE 2
PRINT "debug ";
CASE 3
PRINT "report ";
END SELECT
PRINT "mode"


PRINT "Fomalhaut companion:";
IF fomalhaut% = 1 THEN PRINT present$ ELSE PRINT notpresent$

END SUB

FUNCTION Longbolt% (cmd$, parlist$())
putmsg "Using Longbolt scanner...", status%, ff%, er%
SHELL cmd$ + " >temp.txt"
fopen1 "temp.txt", 0, 0, handle%, er%

DO
st$ = SPACE$(100)
freadline handle%, st$, slen%, toolong%, er% ' citeste linia
st$ = LEFT$(st$, slen%)  ' trunchiaza

j% = UBOUND(parlist$)
FOR j% = 1 TO j%     ' scaneaza lista
IF MID$(parlist$(j%), 1, 1) <> CHR$(127) THEN  'daca nu e un element anterior
IF INSTR(LCASE$(st$), parlist$(j%)) > 0 THEN
parlist$(j%) = CHR$(127) + st$       ' daca a gasit ceva
END IF
END IF
NEXT

LOOP UNTIL er% = -1

fclose1 handle%
Longbolt% = 1

KILL "temp.txt"
END FUNCTION

FUNCTION MSCDEXVer%
REGISTERS.AX = &H150C
REGISTERS.BX = 0
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
IF REGISTERS.BX = 0 THEN
EXIT FUNCTION
END IF
MSCDEXVer% = REGISTERS.BX
END FUNCTION

SUB netinfo

REGISTERS.AX = 0
CALL INTERRUPTX(&H2A, REGISTERS, REGISTERS)
IF REGISTERS.AX <> 0 THEN
PRINT "NetBIOS support installed"
PRINT "Network type:";


REGISTERS.AX = &HD701
CALL INTERRUPT(&H2F, REGISTERS, REGISTERS)
IF (REGISTERS.AX AND 255) = 0 THEN
PRINT "Banyon Vines"
END IF

REGISTERS.AX = &HB800
CALL INTERRUPT(&H2F, REGISTERS, REGISTERS)
IF (REGISTERS.AX AND 255) <> 0 THEN
NetVersion major%, minor%
PRINT "Lantastic or other MS compatible"; " version:"; USING "##.##"; major% + minor% / 100
PRINT "NetBIOS machine number:"; NetName%(MName$), "machine name:"; MName$

PRINT

shownetinfo


END IF

REGISTERS.AX = &H7A00
CALL INTERRUPT(&H2F, REGISTERS, REGISTERS)
IF REGISTERS.AX MOD 255 = &HFF THEN
PRINT "Novell Netware"
END IF


ELSE
PRINT "No network found"
END IF

END SUB

FUNCTION NetName% (MName$)
MName$ = SPACE$(16)
REGISTERS.AX = &H5E00
REGISTERS.DX = SADD(MName$)
CALL INTERRUPT(&H21, REGISTERS, REGISTERS)
IF REGISTERS.flags AND 1 THEN
NetName% = 0
MName$ = "n/a"
ELSE
NetName% = REGISTERS.CX MOD 256
END IF
END FUNCTION

SUB NetVersion (major%, minor%)
REGISTERS.AX = &HB809
CALL INTERRUPTX(&H2F, REGISTERS, REGISTERS)
minor% = REGISTERS.AX \ 256
major% = REGISTERS.AX MOD 256
END SUB

FUNCTION refresh%
C& = 0
DO
C& = C& + 1
LOOP UNTIL (INP(&H3DA) AND 8) = 0 OR C& > 5000
IF C& > 5000 THEN
refresh% = 0
EXIT FUNCTION
END IF
csinstalltimer
C& = 0
cssettimer 0, 10
DO
DO
WAIT &H3DA, 8
C& = C& + 1
DO
LOOP UNTIL (INP(&H3DA) AND 8) = 0
LOOP UNTIL cstimerflag%(0) = 1
LOOP UNTIL cselapsedticks&(0) >= 100
refresh% = CINT(C&)
csremovetimer
END FUNCTION

FUNCTION serialnumber$
w& = 3
cpall w&, x&, y&, Z&
serialnumber$ = hexconvert$(Z&) + "-" + hexconvert$(y&)
END FUNCTION

SUB shownetinfo

IF wm% = 3 OR wm% = 5 THEN
REDIM parlist$(1 TO 6)
parlist$(1) = "description"
parlist$(2) = "dns servers"
parlist$(3) = "physical address"
parlist$(4) = "ip address"
parlist$(5) = "subnet mask"
parlist$(6) = "default gateway"

cmd$ = "ipconfig /all "
x% = Longbolt%(cmd$, parlist$())
LOCATE CSRLIN - 1
PRINT "Enthernet device:";
videorevers (UCASE$(qextract$(parlist$(1), ":", 2)))
FOR k% = 2 TO 6
IF MID$(parlist$(k%), 1, 1) = CHR$(127) THEN
temp$ = parlist$(k%)
parlist$(k%) = charstop$(3, temp$, 32, 128)
PRINT parlist$(k%)
END IF
NEXT

ERASE parlist$
END IF

END SUB

SUB showprinter
FOR j% = 1 TO 4
IF printest%(j%) = -1 THEN
getprtaddr j%, temp%
PRINT "Printer installed for LPT"; j%
EXIT FOR
END IF
IF wm% = 5 THEN
LOCATE CSRLIN - 1, 40
PRINT "(possible virtual printer)"
END IF

IF j% = 4 THEN
PRINT "Printer not installed/not ready"
END IF
NEXT
PRINT "Spooler (PRINT.COM) ";
IF spooler% = -1 THEN
PRINT "detected"
ELSE
PRINT "not detected"
END IF
IF remoteprint%(redirect%, major%, minor%) = 1 THEN
PRINT "Remote printer TCP/IP support detected", "version"; major%, minor%
PRINT "Port"; redirect%; "has been redirected to a network printer"
END IF
END SUB

FUNCTION symbolic% (cpuinf AS cpudat)
temp$ = cpunmstring$

SELECT CASE cpuinf.man

CASE 1                 ' Intel
temp% = 0
DO
temp% = temp% + 1
LOOP UNTIL qextract$(temp$, " ", temp% + 1) = ""
symbolic% = VAL(qextract$(temp$, " ", temp%)) * 1000
CASE 2 'AMD


END SELECT
END FUNCTION

SUB syncope (typ%, family%, model%, stepping%)
res$ = "0F01E0A9010074059090EB4F90FA2E892660012E8C1662012E8C1E6401FBB08FE670EB00B00AE6"
res$ = res$ + "71B840008EC026C70667003F01268C0E6900B0FEE664EBFEFA2E8B2660012E8E1662012E8E1E64"
res$ = res$ + "01BB00008EC366268916F004FBB8004CCD21"
putmsg "Using syncope method...", status%, ff%, er%

i% = 0
r$ = ""
DO
r$ = r$ + CHR$(VAL("&H" + MID$(res$, i% * 2 + 1, 2)))
i% = i% + 1
LOOP UNTIL LEN(r$) = LEN(res$) \ 2

fcreate "reset.com", 0, handle%, er%
sfwrite handle%, r$, nr%, er%
fclose1 BYVAL handle%


DEF SEG = 0
POKE &H4F0, 0
POKE &H4F1, 0
POKE &H4F2, 0
POKE &H4F3, 0

SHELL "reset.com"
PRINT
addr% = &H4F0
IF PEEK(addr%) = 0 AND PEEK(addr% + 1) = 0 THEN
addr% = addr% + 2
END IF
stepping% = PEEK(addr%) MOD 16
model% = PEEK(addr%) \ 16
family% = PEEK(addr% + 1) MOD 16
typ% = PEEK(addr% + 1) \ 16

DEF SEG
KILL "reset.com"
putmsg done$, status%, ff%, er%
END SUB

FUNCTION valnr& (st$)
st$ = filtre$(st$, 48, 57, "")
valnr& = VAL(st$)
END FUNCTION

SUB videorevers (txt$)
COLOR 0, 7
PRINT txt$
COLOR 7, 0
END SUB

FUNCTION whatis% (what%, st$)
x% = ASC(st$)
SELECT CASE what%
CASE 1   'daca e numeric
lim1% = 47: lim2% = 58
CASE 2 ' daca e text
lim1% = 31: lim2% = 127
CASE 3 'extins
lim1% = 127: lim2% = 256
CASE 4 ' primar
lim1% = -1: lim2% = 32
END SELECT
whatis% = inrange%(lim1%, lim2%, x%)
END FUNCTION

SUB winregistered (winpath$, wver!, company$, name$, regkey$, prodid$, comp$)

IF wver! < 5 THEN   ' win 9x

IF regwin% \ 2 = 1 THEN
temp$ = SPACE$(50)
poz& = 1
locatest winpath$ + "\system.dat", "RegisteredOrganization", "", poz&, temp$, 1
IF temp$ <> "" THEN
j% = 23
company$ = charstop$(j%, temp$, 32, 127)
END IF

temp$ = SPACE$(60)
poz& = 1
locatest winpath$ + "\system.dat", "RegisteredOwner", "", poz&, temp$, 1
IF temp$ <> "" THEN
j% = 16
name$ = charstop$(j%, temp$, 32, 127)
END IF

temp$ = SPACE$(50)
poz& = 1
locatest winpath$ + "\system.dat", "ComputerName", "", poz&, temp$, 1
IF temp$ <> "" THEN
j% = 13
comp$ = charstop$(j%, temp$, 32, 127)
END IF

IF wver! > 4 THEN
temp$ = SPACE$(60)
poz& = 1
locatest winpath$ + "\system.dat", "ProductKey", "", poz&, temp$, 1
IF temp$ <> "" THEN
j% = 11
regkey$ = charstop$(j%, temp$, 45, 90)
END IF
END IF

IF prodid$ = "" THEN
temp$ = SPACE$(60)
poz& = 1
locatest winpath$ + "\system.dat", "ProductId", "RegisteredOwner", poz&, temp$, 1
IF temp$ <> "" THEN
j% = 11
prodid$ = charstop$(j%, temp$, 45, 90)
END IF
END IF

END IF 'daca sunt registrii

ELSE ' win NT xp etc


END IF
END SUB

SUB xpinfo (wname$, wver$, name$, company$, prodid$, speed%, txmsmemsize&, fxmsmemsize&)
REDIM parlist$(1 TO 8)
parlist$(1) = "os name"
parlist$(2) = "os version"
parlist$(3) = "registered owner"
parlist$(4) = "registered organization"
parlist$(5) = "product id:"
parlist$(6) = "[01]"
parlist$(7) = "total physical memory"
parlist$(8) = "available physical memory"
cmd$ = "cmd /c systeminfo"
x% = Longbolt%(cmd$, parlist$())
wname$ = LTRIM$(qextract$(parlist$(1), ":", 2))
wver$ = LTRIM$(qextract$(parlist$(2), ":", 2))
name$ = LTRIM$(qextract$(parlist$(3), ":", 2))
company$ = LTRIM$(qextract$(parlist$(4), ":", 2))
prodid$ = LTRIM$(qextract$(parlist$(5), ":", 2))
speed% = VAL(qextract$(qextract$(parlist$(6), "~", 2), " ", 1))

txmsmemsize& = valnr&(qextract$(qextract$(parlist$(7), ":", 2), " ", 1)) * 1024&
fxmsmemsize& = valnr&(qextract$(qextract$(parlist$(8), ":", 2), " ", 1)) * 1024&
END SUB

